#class auto
#define PORTA_AUX_IO

//----------------------------------------------------------------------------
//
//  File generated by S1D13706CFG.EXE
//
//  Copyright (c) 2000,2004 Epson Research and Development, Inc.
//  All rights reserved.
//
//  PLEASE NOTE: If you FTP this file to a non-Windows platform, make
//               sure you transfer this file using ASCII, not BINARY mode.
//
//----------------------------------------------------------------------------

// Panel: 640x480x2bpp 59Hz Color TFT 18-bit (PCLK=25.000MHz)

#define S1D_DISPLAY_WIDTH           640
#define S1D_DISPLAY_HEIGHT          480
#define S1D_DISPLAY_BPP             2
#define S1D_DISPLAY_SCANLINE_BYTES  160
#define S1D_PHYSICAL_VMEM_ADDR      0x00000000L
#define S1D_PHYSICAL_VMEM_SIZE      0x14000L
#define S1D_PHYSICAL_REG_ADDR       0x00000000L
#define S1D_PHYSICAL_REG_SIZE       0x100
#define S1D_DISPLAY_PCLK            25000
#define S1D_PALETTE_SIZE            4
#define S1D_FRAME_RATE              59
#define S1D_POWER_DELAY_ON          50
#define S1D_POWER_DELAY_OFF         1200
#define S1D_REGDELAYOFF             0xFFFE
#define S1D_REGDELAYON              0xFFFF

#define S1D_WRITE_PALETTE(p,i,r,g,b)  \
{  \
    ((volatile S1D_VALUE*)(p))[0x0A/sizeof(S1D_VALUE)] = (S1D_VALUE)(r);  \
    ((volatile S1D_VALUE*)(p))[0x09/sizeof(S1D_VALUE)] = (S1D_VALUE)(g);  \
    ((volatile S1D_VALUE*)(p))[0x08/sizeof(S1D_VALUE)] = (S1D_VALUE)(b);  \
    ((volatile S1D_VALUE*)(p))[0x0B/sizeof(S1D_VALUE)] = (S1D_VALUE)(i);  \
}

#define S1D_READ_PALETTE(p,i,r,g,b)  \
{  \
    ((volatile S1D_VALUE*)(p))[0x0F/sizeof(S1D_VALUE)] = (S1D_VALUE)(i);  \
    r = ((volatile S1D_VALUE*)(p))[0x0E/sizeof(S1D_VALUE)];  \
    g = ((volatile S1D_VALUE*)(p))[0x0D/sizeof(S1D_VALUE)];  \
    b = ((volatile S1D_VALUE*)(p))[0x0C/sizeof(S1D_VALUE)];  \
}

typedef unsigned short S1D_INDEX;
typedef unsigned char  S1D_VALUE;

typedef struct
{
    S1D_INDEX Index;
    S1D_VALUE Value;
} S1D_REGS;

const static S1D_REGS aS1DRegs[] =
{
    {0x04,0x00},   // BUSCLK MEMCLK Config Register
    {0x05,0x12},   // PCLK Config  Register
    {0x10,0x61},   // PANEL Type Register
    {0x11,0x00},   // MOD Rate Register
    {0x12,0x63},   // Horizontal Total Register
    {0x14,0x4F},   // Horizontal Display Period Register
    {0x16,0x8B},   // Horizontal Display Period Start Pos Register 0
    {0x17,0x00},   // Horizontal Display Period Start Pos Register 1
    {0x18,0x0C},   // Vertical Total Register 0
    {0x19,0x02},   // Vertical Total Register 1
    {0x1C,0xDF},   // Vertical Display Period Register 0
    {0x1D,0x01},   // Vertical Display Period Register 1
    {0x1E,0x23},   // Vertical Display Period Start Pos Register 0
    {0x1F,0x00},   // Vertical Display Period Start Pos Register 1
    {0x20,0x5F},   // Horizontal Sync Pulse Width Register
    {0x22,0x00},   // Horizontal Sync Pulse Start Pos Register 0
    {0x23,0x00},   // Horizontal Sync Pulse Start Pos Register 1
    {0x24,0x01},   // Vertical Sync Pulse Width Register
    {0x26,0x00},   // Vertical Sync Pulse Start Pos Register 0
    {0x27,0x00},   // Vertical Sync Pulse Start Pos Register 1
    {0x70,0x01},   // Display Mode Register
    {0x71,0x00},   // Special Effects Register
    {0x74,0x00},   // Main Window Display Start Address Register 0
    {0x75,0x00},   // Main Window Display Start Address Register 1
    {0x76,0x00},   // Main Window Display Start Address Register 2
    {0x78,0x28},   // Main Window Address Offset Register 0
    {0x79,0x00},   // Main Window Address Offset Register 1
    {0x7C,0x00},   // Sub Window Display Start Address Register 0
    {0x7D,0x00},   // Sub Window Display Start Address Register 1
    {0x7E,0x00},   // Sub Window Display Start Address Register 2
    {0x80,0x50},   // Sub Window Address Offset Register 0
    {0x81,0x00},   // Sub Window Address Offset Register 1
    {0x84,0x00},   // Sub Window X Start Pos Register 0
    {0x85,0x00},   // Sub Window X Start Pos Register 1
    {0x88,0x00},   // Sub Window Y Start Pos Register 0
    {0x89,0x00},   // Sub Window Y Start Pos Register 1
    {0x8C,0x4F},   // Sub Window X End Pos Register 0
    {0x8D,0x00},   // Sub Window X End Pos Register 1
    {0x90,0xEF},   // Sub Window Y End Pos Register 0
    {0x91,0x00},   // Sub Window Y End Pos Register 1
    {0xA0,0x00},   // Power Save Config Register
    {0xA1,0x00},   // CPU Access Control Register
    {0xA2,0x00},   // Software Reset Register
    {0xA3,0x00},   // BIG Endian Support Register
    {0xA4,0x00},   // Scratch Pad Register 0
    {0xA5,0x00},   // Scratch Pad Register 1
    {0xA8,0x00},   // GPIO Config Register 0
    {0xA9,0x80},   // GPIO Config Register 1
    {0xAC,0x00},   // GPIO Status Control Register 0
    {0xAD,0x00},   // GPIO Status Control Register 1
    {0xB0,0x00},   // PWM CV Clock Control Register
    {0xB1,0x00},   // PWM CV Clock Config Register
    {0xB2,0x00},   // CV Clock Burst Length Register
    {0xB3,0x00},   // PWM Clock Duty Cycle Register
};




#define S1DNUMREGS 54
#define S1DMEMSIZE 76800

typedef union {
	unsigned char RGB[3];
} triplet;

const triplet pal0[S1D_PALETTE_SIZE]= {
	{  0,  0,  0},
	{  0,  0,  0},
	{  0,  0,  0},
	{  0,  0,  0},
};


const triplet pal1[S1D_PALETTE_SIZE]= {
	{  0,  0,  0},
	{  255,  0,  0},
	{  0,  255,  0},
	{  255,255,255},
};

const triplet pal2[S1D_PALETTE_SIZE]= {
	{  255,255,255},
	{  255,  0,  0},
	{  0,  255,  0},
	{  0,		0,255},
};

const triplet pppal[S1D_PALETTE_SIZE]= {
	{  255,255,255},
	{  0,  255,  0},
	{  0,  0,  0},
	{  0,		0,255},
};

const triplet pdmpal[S1D_PALETTE_SIZE]= {
	{  0,0,0},
	{  0xC0, 0x9B, 0x87},
	{  0x82, 0x3D, 0x19},
	{  0xA0, 0x6C, 0x51},
};

#asm root
read13706::
		call addressbus		; put addresses and BHE
      ex de,hl
      ioe ld a,(hl)			; lee port paralelo
      ld h,0
      ld l,a
      ret

;sp+2: A0-A15
;sp+4: A16
;sp+6: data
write13706::
		call addressbus		; put addresses and BHE
		ld hl,(sp+6)			; lee dato
      ld a,l
      ex de,hl
      ioe ld (HL),a			; pone dato
      ret

;sp+2: return address for calling function
;sp+4: A0-A15
;sp+6: A16
;sp+8: data
addressbus:
		ld hl,(sp+4)			; lee address
      ex de,hl					; en DE
		ld hl,(sp+6)			; lee address A16
      ld a,l					; en A
ab2:	ld hl,PGDR				; apunta a port
		ioi ld (hl),d			; pone parte alta
		ld hl,PDDR				; apunta a port
		ioi ld (hl),e			; pone parte baja (7,6)
		ld hl,PCDR				; apunta a port
      ioi res 4,(HL)			; A16=0
		rrca						; A16=1 ?
		jr nc,ok3	  			; no
      ioi set 4,(HL)			; s, A16=1
ok3:
      ld a,e					; A= A7-A0
		ld hl,PBDR				; apunta a port paralelo
		ioi set 0,(hl)			; BHE=1
		rrc e						; debo activar BHE ? (test LSB=1)
		jr nc,ok1	  			; no
      ioi res 0,(HL)			; s, BHE=0
ok1:
		and 0x3F					; A6,A7 = 0
      ld e,a
      ld d,0x80				; I/O = 0x8000 + A5-A0 = 10000000 00xxxxxx
		ret


;IY: A0-A15
;A: A16
;(IX+0): data left
;(IX+1): data right
writew13706:
		ld a',a					; save A16
		ld hl,iy					; get A15-A0
      ex de,hl					; in DE
		call ab2					; put addresses and BHE
		ld a,(IX+0)				; lee dato
      ex de,hl
      ioe ld (HL),a			; pone dato
      ex af,af'				; restore A16
		ld hl,iy					; lee address
		ld	de,0x0001			; next byte
		add hl,de				; inc address
		adc a,d	  				; (adc a,0x00) propagate carry
      ex de,hl					; A15-A0 in DE
		ld a',a					; save A16
      call ab2					; address bus
      ex de,hl
		ld a,(IX+1)				; lee dato
      ioe ld (HL),a			; pone dato
      ex af,af'				; restore A16
      ret

xdumpblk::
		ld		a,xpc								; save the frame pointer, and xpc
		push	af
		push	ix

		ld		hl,(sp+12)						; Get mem address (long) in BC:DE
      ld		c,l
      ld		b,h
		ld		hl,(sp+10)
		ex		de,hl

		; Convert BC:DE to a normalized XMEM pointer
		call	LongToXaddr						; DE = logical address, A = xpc
		ld    xpc,a
      ex 	de,hl
  		ld		ix,hl								; IX = source


		ld		iy,(sp+6)						; a:iy=dest, hl=length
		ld		hl,(sp+8)
		ld		a,l
		ld		hl,(sp+14)

		ld		c,h								; c:b=length
		ld		b,l
		ex		af,af'
		ld		a,l
		or		a
		jr		nz,.xcbf_2
		dec	c
.xcbf_2:
		ex		af,af'

xcbf_loop:
      call	writew13706						; preserve BC,IX,IY,A
		ld		de,0x0002						; 6 copying word by word
		add	ix,de								; 4
		add	iy,de								; 4
		adc	a,d								; 2, (adc a,0x00) propagate carry
		djnz	xcbf_loop						; 5, critical path word
		dec	c
		jp		p,xcbf_loop

xcbf_done:
		pop	ix
		pop	af
		ld		xpc,a
		ret


;sp+2: A0-A15
;sp+4: A16
;sp+6: len
xclrblk::
		ld		iy,(sp+2)						; a:iy=dest, hl=length
		ld		hl,(sp+4)
		ld		a,l
		ld		hl,(sp+6)
		ld		c,h								; c:b=length
		ld		b,l
		ex		af,af'
		ld		a,l
		or		a
		jr		nz,.xbf_2
		dec	c
.xbf_2:
		ex		af,af'

xbf_loop:
		ld a',a					; save A16
		ld hl,iy					; get A15-A0
      ex de,hl					; in DE
		call ab2					; put addresses and BHE
		xor a						; dato
      ex de,hl
      ioe ld (HL),a			; pone dato
      ex af,af'				; restore A16
		ld	 de,0x0001
		add iy,de
		adc a,d	 				; (adc a,0x00) propagate carry
		djnz xbf_loop
		dec c
		jp	p,xbf_loop
		ret
#endasm


void writepalette(triplet *address)
{
int i;
unsigned char *ptr;

	ptr=&(address->RGB[0]);
   BitWrPortI(PCDR,&PCDRShadow,0,2);					// M/R=0 => registers
	for(i=0;i<S1D_PALETTE_SIZE;i++){
     write13706(0x0AL,*ptr++);
	  write13706(0x09L,*ptr++);
	  write13706(0x08L,*ptr++);
	  write13706(0x0BL,i);
   }
   BitWrPortI(PCDR,&PCDRShadow,1,2);					// M/R=1 => memory
}


void init13706()
{
int i;

   BitWrPortI(PCDR,&PCDRShadow,0,2);					// M/R=0 => registers
	for(i=1;i<S1DNUMREGS;i++)
   	write13706((long)(aS1DRegs[i].Index),aS1DRegs[i].Value);
   writepalette(pal1);     				// returns M/R=1 => memory
}

void LCD_fill(unsigned long address, unsigned long len, unsigned char color)
{
	color|=(color<<2);
	color|=(color<<4);

	while(len--)
   	write13706(address++,color);
}

//#define LCD_clear() LCD_fill(0,S1DMEMSIZE,0)
#define LCD_clear() xclrblk(0L,(int)(S1DMEMSIZE/4));xclrblk(S1DMEMSIZE/4,(int)(S1DMEMSIZE/4));\
xclrblk(S1DMEMSIZE/2,(int)(S1DMEMSIZE/4));xclrblk(S1DMEMSIZE/2+S1DMEMSIZE/4,(int)(S1DMEMSIZE/4))

/* Plot image data, 4 pixels per byte, MSB left */

void LCD_plot (int x, int y, unsigned char color)
{
unsigned int strip,nibble,data;
unsigned long addr;

	color&=3;
	strip=(unsigned int)x>>2; 						// strip = x/4
	nibble=x&'\B011';	  								// nibble = remainder
	addr=strip+160L*y;								// calculate address
	data=read13706(addr);							// get data at that address
	switch(nibble){
   case 3:
      data&=0xFC;										// clear pixel bits
		data|=color;									// set pixel color (MSB left)
   	break;
   case 2:
      data&=0xF3;
      data|=(color<<2);
   	break;
   case 1:
      data&=0xCF;
      data|=(color<<4);
   	break;
   case 0:
      data&=0x3F;
      data|=(color<<6);
   	break;
   }
	write13706(addr,data);
}



/* Read image files, store them as [(long)lenght][data...] in xmem
Image data can be extracted from BMP format (without the header), but
vertically mirrored.
Take a desired image, resize to 640x480, color reduce to 4 colors,
mirror verticaly (rotate 180, flip horizontally).
Save to file, remove 118 byte header with your preferred hex editor
Extract color palette from bytes 54-69 (R G B 0) and reduce to R G B
Pitifully, you will have to pack two bytes in one byte, as BMP seems
to use a nibble per color (and pixel reversed...).
*/

#ximport "pp.pbm" pp
#ximport "pdm.pbm" pdm


root useix void LCD_dump(long imgdata, triplet *paldata)
{

long dest;
unsigned int tocopy,len;


	len=S1DMEMSIZE/2;
   dest=0;
   imgdata+=sizeof(long);
   writepalette(paldata);
		while(len) {
			tocopy=2048-(int)(dest&2047);
			if(tocopy>len)
				tocopy=len;
			xdumpblk(dest,imgdata,tocopy);
			dest+=(tocopy<<1);
			imgdata+=(tocopy<<1);
			len-=tocopy;
		}

}

root useix void LCD_icon(unsigned long imgdata, int x, int y, int width, int height)
{

unsigned long dest;

// width must be even (8-pixel units)

   dest=(x>>2)+160L*y;
   imgdata+=sizeof(unsigned long);
   width>>=2;
	while(height--) {
			xdumpblk(dest,imgdata,width>>1);
			dest+=160L;
			imgdata+=width;
	}

}

// Bresenham Line Algorithm

void LCD_line(int x1,int y1,int x2,int y2, unsigned char color)
{
int  x,y,dx,dy,incx,incy,balance;

        if (x2 >= x1){
                dx = x2 - x1;
                incx = 1;
        }
        else {
                dx = x1 - x2;
                incx = -1;
        }

        if (y2 >= y1) {
                dy = y2 - y1;
                incy = 1;
        }
        else {
                dy = y1 - y2;
                incy = -1;
        }

        x = x1;
        y = y1;

        if (dx >= dy) {
                dy <<= 1;
                balance = dy - dx;
                dx <<= 1;

                while (x != x2) {
                        LCD_plot(x, y,color);
                        if (balance >= 0) {
                                y += incy;
                                balance -= dx;
                        }
                        balance += dy;
                        x += incx;
                }
                LCD_plot(x, y,color);
        }
        else {
                dx <<= 1;
                balance = dx - dy;
                dy <<= 1;

                while (y != y2) {
                        LCD_plot(x, y,color);
                        if (balance >= 0) {
                                x += incx;
                                balance -= dy;
                        }
                        balance += dx;
                        y += incy;
                }
                LCD_plot(x, y,color);
        }
}


#define LCD_rectangle(x1,y1,x2,y2,c) \
{ \
	LCD_line(x1,y1,x2,y1,c); \
	LCD_line(x2,y1,x2,y2,c); \
	LCD_line(x2,y2,x1,y2,c); \
	LCD_line(x1,y2,x1,y1,c); \
}


/* simple 3D function plotting */

void paraboloide(int PERSP,float SCALE,int TRAZOSX,int TRAZOSY,float X0,float X1,float Y0,float Y1,unsigned char pcolor)
{
auto int xx,yy;
auto float x,y,z;
auto float persp,xt,zt;
auto float h1,h2,h3,h4,cs,si;

	persp=PERSP*0.01745329;			// convert to radians
	cs=cos(persp);
	si=sin(persp);
	h1=(X1-X0)/159;
	h2=(Y1-Y0)/(float)(TRAZOSX-1);
	h3=(X1-X0)/(float)(TRAZOSY-1);
	h4=(Y1-Y0)/159;

	for(y=Y0;y<=Y1;y+=h2)
		for(x=X0;x<=X1;x+=h1){
			z=x*x/4+y*y/9-15;
			xt=x-y*cs;
			zt=z-y*si;
			xx=320+(int)(SCALE*xt);
			yy=240-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
	for(x=X0;x<=X1;x+=h3)
		for(y=Y0;y<=Y1;y+=h4) {
			z=x*x/4+y*y/9-15;
			xt=x-y*cs;
			zt=z-y*si;
			xx=320+(int)(SCALE*xt);
			yy=240-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
}

void elipsoide(int PERSP,float SCALE,int TRAZOSX,int TRAZOSY,float X0,float X1,float Y0,float Y1,unsigned char pcolor)
{
auto int xx,yy;
auto float x,y,z;
auto float persp,xt,yt,zt;
auto float h1,h2,h3,h4,cs,si;

	persp=PERSP*0.01745329;			// convert to radians
	cs=cos(persp);
	si=sin(persp);
	h1=(X1-X0)/159;
	h2=(Y1-Y0)/(float)(TRAZOSX-1);
	h3=(X1-X0)/(float)(TRAZOSY-1);
	h4=(Y1-Y0)/159;

	for(y=Y0;y<=Y1;y+=h2)
		for(x=X0;x<=X1;x+=h1){
			xt=cos(x)*cos(y);
			yt=sin(x)*cos(y);
			zt=sin(y);
			xt-=yt*cs;
			zt-=yt*si;
			xx=320+(int)(SCALE*xt);
			yy=240-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
	for(x=X0;x<=X1;x+=h3)
		for(y=Y0;y<=Y1;y+=h4) {
			xt=cos(x)*cos(y);
			yt=sin(x)*cos(y);
			zt=sin(y);
			xt-=yt*cs;
			zt-=yt*si;
			xx=320+(int)(SCALE*xt);
			yy=240-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
}

#use "6X8L.lib"
#use "12X16L.lib"

typedef struct {
	unsigned long *font;
	unsigned char	lpc;           // lines per character
	unsigned char	Bpcl;          // bytes per character line (1 or 2)
	unsigned char	bpcl;          // bits per character line
} FontInfo;

const static FontInfo fontinfo[]={
{&Font6x8,8,1,6},
{&Font12x16,16,2,12}
};

nodebug void LCD_putchr ( int font, unsigned long daddress, char chr , int color, int bcolor)
{
int i,j,ii,jj;
unsigned long address,dispaddress;
int data,ddata,aux;

	i=fontinfo[font].lpc;			// lines per character
	ii=fontinfo[font].Bpcl;			// bytes per character line
   jj=fontinfo[font].bpcl;			// bits per character line
	address=*(fontinfo[font].font)+i*ii*(chr-0x20);
   dispaddress=daddress;
	while(i--){
   	data=xgetint(address);
		aux=(data&0xFF)<<8;			// swap bytes
      data=((data>>8)&0xFF)+aux;
      address+=ii;
      j=jj;
      while(j--){
	      ddata=read13706((unsigned long)dispaddress>>2);		// get display data
			if(data&0x8000)
         	aux=color;
      	else
				aux=bcolor;		// bcolor =-1 => transparent
         if(aux!= -1){
				switch((int)dispaddress&3){
			   case 3:
			      ddata&=0xFC;										// clear pixel bits
					ddata|=aux;											// set pixel color (MSB left)
			   	break;
			   case 2:
			      ddata&=0xF3;
			      ddata|=(aux<<2);
			   	break;
			   case 1:
			      ddata&=0xCF;
			      ddata|=(aux<<4);
			   	break;
			   case 0:
			      ddata&=0x3F;
			      ddata|=(aux<<6);
			   	break;
			   }
         }
			write13706((unsigned long)dispaddress>>2,ddata);
      	data<<=1;
         dispaddress++;
      }
	   dispaddress=daddress+=640;	// next line
	}
}

void LCD_printat (int font, unsigned int row, unsigned int col, char *ptr, int color, int bcolor)
{
unsigned long address;

  	address=640L*row;
	do {
   	address+=col;
		LCD_putchr (font,address,*ptr++,color,bcolor);
      col=fontinfo[font].bpcl;
	} 	while (*ptr);
}


void MsDelay ( int iDelay )
{
	unsigned long ul0;
	ul0 = MS_TIMER;		// get current timer value
	while ( MS_TIMER < ul0 + (unsigned long) iDelay );
}

void fadein(triplet *address)
{
int i,j;
unsigned char *ptr;

   BitWrPortI(PCDR,&PCDRShadow,0,2);					// M/R=0 => registers
	for(j=0;j<=256;j++){
		ptr=&(address->RGB[0]);
		for(i=0;i<S1D_PALETTE_SIZE;i++){
	     write13706(0x0AL,((*ptr++)*j)/256);
		  write13706(0x09L,((*ptr++)*j)/256);
		  write13706(0x08L,((*ptr++)*j)/256);
		  write13706(0x0BL,i);
	   }
      MsDelay(8);
   }
   BitWrPortI(PCDR,&PCDRShadow,1,2);					// M/R=1 => memory
}

void fadeout(triplet *address)
{
int i,j;
unsigned char *ptr;

   BitWrPortI(PCDR,&PCDRShadow,0,2);					// M/R=0 => registers
	for(j=256;j>=0;j--){
		ptr=&(address->RGB[0]);
		for(i=0;i<S1D_PALETTE_SIZE;i++){
	     write13706(0x0AL,((*ptr++)*j)/256);
		  write13706(0x09L,((*ptr++)*j)/256);
		  write13706(0x08L,((*ptr++)*j)/256);
		  write13706(0x0BL,i);
	   }
      MsDelay(8);
   }
   BitWrPortI(PCDR,&PCDRShadow,1,2);					// M/R=1 => memory
}

main()
{
unsigned int i,j,y,oldy;
unsigned char string[5];

	WrPortI ( PGDDR,&PGDDRShadow,'\B11111111' );
	WrPortI ( PEDDR,&PEDDRShadow,'\B00010000' );
	WrPortI ( PDDDR,&PDDDRShadow,'\B11000000' );
	WrPortI ( PBDDR,&PBDDRShadow,'\B11111111' );
	WrPortI ( PBDR,&PBDRShadow,'\B11000000' );
	WrPortI ( PCDR,&PCDRShadow,'\B11101111' );		// AB16=0, M/R = M

// Use Port E bit 4 for Chip Select with 7 wait-states
#define STROBE			0x10
#define CSREGISTER	IB4CR
#define CSSHADOW		IB4CRShadow
#define CSCONFIG		0x48

	// Initialize Port E bit to be a normal I/O pin
	WrPortI(PEFR, &PEFRShadow, (PEFRShadow|STROBE));

	// Initialize Port E bit to be an output pin
	WrPortI(PEDDR, &PEDDRShadow, (PEDDRShadow|STROBE));

	// Initialize Port E bit to be a chip select.
	WrPortI(CSREGISTER, &CSSHADOW, CSCONFIG);

	// Set Port E bit to be clocked by PCLK/2
	WrPortI(PECR, &PECRShadow, (PECRShadow & ~0xFF));

	init13706();
//   BitWrPortI(PCDR,&PCDRShadow,0,2);					// M/R=0 => registers
//	printf("ID: %0x\n",read13706(0L));
//   MsDelay(1000);
//  	write13706(0xADL,0x80);
//   BitWrPortI(PCDR,&PCDRShadow,1,2);					// M/R=1 => memory

   while(1){
		LCD_clear();
	   writepalette(pal0);
      LCD_icon(pdm,20,100,600,241);
      fadein(pdmpal);
		MsDelay ( 3000 );						// wait 3 secs
      fadeout(pdmpal);
		LCD_clear();
	   writepalette(pal1);
		LCD_rectangle(0,0,639,479,3);
 		for(i=0;i<16;i++) {
			LCD_rectangle(21*i+3,11*i+3,17*i+240,11*i+81,1);
			LCD_rectangle(13*i+5,13*i+5,19*i+240,13*i+83,2);
	   }
		MsDelay ( 1000 );						// wait 1 secs
		LCD_clear();
		LCD_rectangle(10,5,128,45,1);
		LCD_rectangle(8,3,130,47,2);
		LCD_printat(0,20,20,"Cika Electronica",3,0);
		MsDelay ( 3000 );						// wait 5 secs
		LCD_clear();
		paraboloide(30,12,20,20,-8.0,8.0,-10.0,10.0,3);
		LCD_printat(1,20,20,"Cika Electronica",3,1);
		MsDelay ( 5000 );	 					// wait 5 secs
		elipsoide(45,160.0,30,30,0,6.28,-3.14,3.14,1);
		LCD_printat(1,50,100,"Cika Electronica",2,-1);
		MsDelay ( 5000 );						// wait 5 secs
		LCD_dump(pp,pppal);			// show gfx
		MsDelay ( 15000 );						// wait 15 secs
		LCD_clear();
	   writepalette(pal1);
		LCD_line(0,240,639,240,3);
      for(i=0;i<640;i++){
      	oldy=y;
        	y=240-239*sin(2*PI*i/640)*cos(17*PI*i/640);
      	if(i==0)
	      	LCD_plot(i,y,2);
         else
      		LCD_line(i-1,oldy,i,y,2);
      }
      for(i=0;i<640;i++){
      	oldy=y;
      	y=240+239*cos(5*PI*i/640)*cos(PI*i/640);
      	if(i==0)
	      	LCD_plot(i,y,1);
         else
      		LCD_line(i-1,oldy,i,y,1);
      }
      for(i=0;i<10;i++){
      	LCD_line(64*i,235,64*i,245,3);
      	sprintf(string,"%d",i);
			LCD_printat(0,250,64*i,string,3,-1);
      }
		LCD_printat(1,0,0,"Dermopirifilacion",3,-1);
		LCD_printat(1,0,500,"Sensor A",1,-1);
		LCD_printat(1,20,500,"Sensor B",2,-1);
		MsDelay ( 10000 );						// wait 10 secs
	   writepalette(pal2);
		MsDelay ( 10000 );						// wait 10 secs
   }
}

